package dk.nsp.idsas.ws._20230601;

import dk.nsp.idsas.ws.IdsasAbstractWS;
import dk.sundhedsdatastyrelsen.identitetssloering._2023._06._01.BlurredOrganisationsResponseType;
import dk.sundhedsdatastyrelsen.identitetssloering._2023._06._01.GetBlurredOrganisationsRequestType;
import dk.sundhedsdatastyrelsen.identitetssloering._2023._06._01.IdsasLookupServicePortType;
import org.apache.log4j.Logger;

import javax.jws.WebService;
import javax.servlet.annotation.WebServlet;
import javax.xml.ws.BindingType;
import javax.xml.ws.soap.Addressing;

import static javax.xml.ws.soap.SOAPBinding.SOAP11HTTP_BINDING;

@WebServlet(name="IdsasLookupService", urlPatterns={"/20230601/lookup"})
@WebService(serviceName = "IdsasLookupService", wsdlLocation = "wsdl/20230601/idsas-lookup.wsdl",
        targetNamespace = "http://sundhedsdatastyrelsen.dk/identitetssloering/2023/06/01/",
        portName = "IdsasLookupServicePort")
@BindingType(value = SOAP11HTTP_BINDING)
public class IdsasLookupServiceWS extends IdsasAbstractWS implements IdsasLookupServicePortType {
    private static final Logger logger = Logger.getLogger(IdsasLookupServiceWS.class);

    @Override
    public BlurredOrganisationsResponseType getBlurredOrganisations(GetBlurredOrganisationsRequestType getBlurredOrganisationsRequest) {
        logger.info(String.format("Enter get blurred organisations for patient %s", getBlurredOrganisationsRequest.getPatientId().getId()));
        return new BlurredOrganisationsResponseType();
    }
}
