package dk.nsp.idsas.ws._20230601;

import javax.jws.WebService;
import javax.servlet.annotation.WebServlet;
import javax.xml.ws.BindingType;
import javax.xml.ws.soap.Addressing;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;

import dk.sundhedsdatastyrelsen.identitetssloering._2023._06._01.CreateBlurringRequestType;
import dk.sundhedsdatastyrelsen.identitetssloering._2023._06._01.EmptyRequest;
import dk.sundhedsdatastyrelsen.identitetssloering._2023._06._01.GetSaltRequestType;
import dk.sundhedsdatastyrelsen.identitetssloering._2023._06._01.IdsasServicePortType;

import dk.nsp.idsas.security.IdsasActorBuilder;
import dk.nsp.idsas.security.model.IdsasActor;
import dk.nsp.idsas.util.WhitelistType;
import dk.nsp.idsas.ws.IdsasAbstractWS;

import static javax.xml.ws.soap.SOAPBinding.SOAP11HTTP_BINDING;

@WebServlet(name="IdsasService", urlPatterns={"/20230601/service"})
@WebService(serviceName = "IdsasService", wsdlLocation = "wsdl/20230601/idsas-service.wsdl",
        targetNamespace = "http://sundhedsdatastyrelsen.dk/identitetssloering/2023/06/01/",
        portName = "IdsasServicePort")
@BindingType(value = SOAP11HTTP_BINDING)
public class IdsasServiceWS extends IdsasAbstractWS implements IdsasServicePortType {
    private static final Logger logger = Logger.getLogger(IdsasServiceWS.class);

    @Autowired
    private IdsasActorBuilder idsasContextBuilder;

    @Override
    public String createBlurring(CreateBlurringRequestType createBlurringRequest) {
        IdsasActor actor = getValidatedIdsasActor(WhitelistType.BLURRING);
        logger.info(String.format("Enter create blurring for cvr '%s', patient '%s'", actor.getCvr(), createBlurringRequest.getPatientId().getId()));
        return "OK";
    }

    @Override
    public String getSalt(GetSaltRequestType getSaltRequest) {
        IdsasActor actor = getValidatedIdsasActor(WhitelistType.SALT);
        logger.info(String.format("Enter get salt for cvr '%s', date '%s'", actor.getCvr(), getSaltRequest.getDateTime()));

        return "getSalt: " + getSaltRequest.getDateTime();
    }

    @Override
    public String getCurrentSalt(EmptyRequest getCurrentSaltRequest) {
        IdsasActor actor = getValidatedIdsasActor(WhitelistType.SALT);
        logger.info(String.format("Enter get current salt for cvr '%s'", actor.getCvr()));

        return "getCurrentSalt";
    }
}
