package dk.nsp.idsas.dao;

import dk.nsp.idsas.setup.DataSourceTestConfiguration;
import dk.nsp.idsas.util.WhitelistType;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringRunner;

import javax.sql.DataSource;

import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;

@RunWith(SpringRunner.class)
@ContextConfiguration(classes = {DataSourceTestConfiguration.class})
public class WhitelistDaoTest {
    @Autowired
    DataSource dataSource;
    private WhitelistDao whitelistDao;

    @Before
    public void setUp() throws Exception {
        whitelistDao = new WhitelistDao(dataSource);
    }

    @Test
    public void isWhitelisted_WhenCvrIsNotWhitelisted_ReturnsFalse() {
        boolean result = whitelistDao.isWhitelisted("0000", WhitelistType.SALT);

        assertFalse(result);
    }

    @Test
    public void isWhitelisted_WhenCvrIsWhitelistedForType_ReturnsTrue() {
        boolean result = whitelistDao.isWhitelisted("1234", WhitelistType.SALT);

        assertTrue(result);
    }

    @Test
    public void isWhitelisted_WhenCvrIsWhitelistedDifferentType_ReturnsFalse() {
        boolean result = whitelistDao.isWhitelisted("1234", WhitelistType.BLURRING);

        assertFalse(result);
    }
}